import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class sword here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Sword extends Actor
{
    
    boolean swinging = false;
    
    public Sword(){
        this.getImage().scale((int)(getImage().getWidth() * 2.5), (int)(getImage().getHeight() * 2.5));
    }
    /**
     * Act - do whatever the sword wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        detectHit();
    }
    
    
    public void swing(){
        this.setImage("sword2.png");
        this.getImage().scale((int)(getImage().getWidth() * 2.5), (int)(getImage().getHeight() * 2.5));
        swinging = true;
        
    }
    
    public void revert(){
        this.setImage("sword.png");
        this.getImage().scale((int)(getImage().getWidth() * 2.5), (int)(getImage().getHeight() * 2.5));
        
        swinging = false;
    }
    
    public void detectHit(){
        if(swinging){
            if(this.isTouching(Enemy.class)){
                Enemy enemy = (Enemy)this.getOneIntersectingObject(Enemy.class);
                if(enemy.getInvincibility() <= 0){
                    enemy.loseHealth(this);
                }
            }else if(this.isTouching(randomEnemy.class)){
                randomEnemy enemy = (randomEnemy)this.getOneIntersectingObject(randomEnemy.class);
                if(enemy.getInvincibility() <= 0){
                    enemy.loseHealth(this);
                }
            }else if(this.isTouching(Copyrighted.class)){
                Copyrighted copyright = (Copyrighted)this.getOneIntersectingObject(Copyrighted.class);
                if(copyright.getInvincibility() <= 0){
                    copyright.loseHealth();
                }
            }
        }
    }
}
