import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Boss here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Copyrighted extends Actor
{
    int health;
    
    int timer;
    int count;
    
    int half;
    boolean testHalf = false;
    
    World world;
    
    Player pl;
    
    int move = 4;
    int moveCount;
    
    int currentX;
    int currentY;
    
    int invincibility = 0;
    public Copyrighted(int health, World world, Player pl){
        
        this.getImage().scale(this.getImage().getWidth() * 2, this.getImage().getHeight() * 2);        
        this.health = health;
        this.half = health / 2;
        this.timer = 8 * 60;
        
        this.world = world;
        this.pl = pl;
    }
    
    /**
     * Act - do whatever the Boss wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(!this.isTouching(Wall.class)){
            currentX = this.getX();
            currentY = this.getY();
        }
        
        if(count >= timer){
            count = 0;
            makeEnemy();
            
            if(testHalf){
                makeEnemy();
            }
        }
        
        if(moveCount >= move){
            move();
            moveCount = 0;
        }else{
            moveCount++;
        }
        
        
        if(invincibility > 0){
            invincibility--;
        }
        count++;
        detectWall();
    }
    public void loseHealth(){
        this.health--;
        invincibility = 25;
        testHalf();
        testDead();
    }
    
    public void testDead(){
        if(this.health <= 0){
            world.removeObject(this);
            world.addObject(new Door(3), world.getWidth() / 2, world.getHeight() / 2);
        }
    }
    
    public void testHalf(){
        if(health <= half){
            this.testHalf = true;
            timer = 10 * 60;
            move = 3;
        }
    }
    
    public void makeEnemy(){
        Random rand = new Random();
        
        int xOff = rand.nextInt(64) - 31;
        int yOff = rand.nextInt(64) - 31;
        
        world.addObject(new Enemy(2, pl), this.getX() + xOff, this.getY() + yOff);
    }
    
    public void move(){
        this.turnTowards(pl.getX(), pl.getY());
        move(1);
    }
    
    public void detectWall(){
        if(this.isTouching(Wall.class)){
            this.setLocation(currentX, currentY);
            move(-1);
        }
    }
    
    public int getInvincibility(){
        return this.invincibility;
    }
}
