import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class randomEnemy extends Actor
{
    int invincibility;
    int hp;
    int delay = 0;
    int moveDelay = 0;
    
    int knockback = 0;
    double kbDis = 5;
    
    boolean allowMovement;
    Player pl;
    
    int currentX;
    int currentY;
    
    int changeDir = 0;
    public randomEnemy(int hp, Player pl){
        this.pl = pl;
        this.hp = hp;
        this.turnTowards(pl.getX(), pl.getY());
    }
    
    /**
     * Act - do whatever the enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        
        if(this.isTouching(Wall.class)){
            currentX = this.getX();
            currentY = this.getY();
        }
        if(invincibility > 0){
            invincibility--;
        }
        
        if(knockback > 0){
            allowMovement = false;
            moveDelay = 0;
            if(delay >= 2){
                knockback--;
                delay = 0;
                knockback((int)kbDis);
                kbDis -= 0.7;
            }else{
                delay++;
            }
        }else{
            allowMovement = true;
            kbDis = 7.0;
            delay = 0;
        }
        
        
        if(allowMovement){
            if(moveDelay >= 2){
                if(changeDir >= 60){
                    move(true);
                    changeDir = 0;
                }else{
                    move(false);
                }
                moveDelay = 0;
                
            }
            moveDelay++;
            changeDir++;
        }
        
        detectWall();
    }
    
    public void loseHealth(Actor weapon){
        hp--;
        
        invincibility = 25;
        //Sword swd = (Sword)this.getOneIntersectingObject(Sword.class);
        int wepX = weapon.getX();
        int wepY = weapon.getY();
        this.turnTowards(wepX, wepY);
        
        knockback = 10;
        testDead();
        
    }
    
    public void move(boolean change){
        if(change){
            Random rand = new Random();
            int rot = rand.nextInt(8) * 45;
            this.setRotation(rot);
            
        }
        move(1);
    }
    
    public void knockback(int dis){
        
        this.move(dis * -1);
        
    }
    public void testDead(){
        if(hp <= 0){
            this.getWorld().removeObject(this);
            pl.increaseScore();
        }
    }
    
    public int getInvincibility(){
        return this.invincibility;
    }
    
    public void detectWall(){
        if(this.isTouching(Wall.class)){
            this.setLocation(currentX, currentY);
            this.move(-1);
        }    
    
    }
    
}
